
	.globl quicksort
	.globl recursiveFactorial
	.globl recursiveFibonacci
	.globl selectionSort
	.globl square
	.globl concat
	.extern printf
	
	

// square(x) prints x and its square

square:
    MOV X20, X30     // Save return address in X20
    FMUL D1, D0, D0  // Put square of D0 in D1
    LDR X0, =sqstr   // Address of string in X0
    BL printf        // Call printf
    MOV X30, X20     // Restore return address to X30
    RET

sqstr: .asciz "The square of %f is %f\n"
     .balign 4



// void selectionSort( long long int B[] )  sorts the array B
// This function will call the maxLoc() function, defined below!

selectionSort:
       // stub function just returns B without sorting
    ret



// void quicksort(double A[], long long int low, long long int hi);
// This function will call the quicksortStep() function, defined below!

quicksort:
        // stub function just returns A without sorting
    ret



// char* concat( char* a, char* b )  concatenates two strings
// This function will use standard functions malloc, strlen, and strcpy.

concat:
      // stub fucntion just returns a
	ret



// --------------------  Nothing below this line needs to be changed --------------------

// long long int maxLoc(long long int B[], count)
// returns the index of the largest element among B[0], B[1], ..., B[count-1]
// precondition:  count >= 1

maxLoc:
    mov x2, #0              // index into array starts at zero
    ldr x3, [x0,x2,lsl #3]  // x3 = B[index], largest item seen so far
    mov x4, #0              // location of largest item seen
maxLocLoop:
    add x2, x2, #1          // index = index + 1
    cmp x2,x1               // if index is equal to count
    b.eq maxLocDone         //     then we are done
    ldr x5, [x0,x2,lsl #3]  // x5 = B[index]
    cmp x5, x3              // if x5 < largest item seen so far,
    b.lt maxLocLoop         //    go onto next index
    mov x3, x5              // x5 is now the largest item seen
    mov x4, x2              // and its index is x2
    b maxLocLoop
maxLocDone:
    mov x0, x4
    ret



// long long int quicksortStep(double A[], long long int low, long long int hi);
// precondition:  hi >= low

quicksortStep:
    ldr D0, [X0, x1, LSL #3]    // D0 is temp
qqsLoop:
    cmp X1, X2     // when hi == low, we are finished
    b.eq qqsDone
	ldr D1, [X0, X2, LSL #3]  // D1 is A[hi]
	fcmp D1,D0
	b.lt qqsMove1
	sub X2, X2, #1  // hi--
	b qqsLoop
qqsMove1:
    str D1, [X0, X1, LSL #3]  // A[low] = D1
    add X1, X1, #1   // low++
qqsLoop2:
    cmp X1, X2
    b.eq qqsDone
    ldr D1, [X0, X1, LSL #3]   // D1 = A[low[
    fcmp D1, D0
    b.gt qqsMove2
    add x1, x1, #1  // low++
    b qqsLoop2
qqsMove2:
    str D1, [X0, X2, LSL #3]  // A[hi] = D1
    sub X2, X2, #1   // hi--
    b qqsLoop
qqsDone:
	str D0, [x0, x1, LSL #3]
	mov X0, X1
    ret



// unsigned long long int recursiveFactorial(unsigned  long long int N) {

recursiveFactorial:
    cmp x0, #1     // if N > 1
    B.HI fact1     //    do the recursion
    mov x0, #1     // otherwise, return value is 1
    ret
fact1:
    sub sp, sp, #16         // make room on stack
    stur x30, [sp,#8]       // save return address on stack
    stur x0,  [sp,#0]       // save N on stack
    sub x0, x0,#1           // x0 = N - 1
    bl recursiveFactorial   // call function recusively on N-1
    ldur x1, [sp,#0]        // retrieve N from stack into x1
    ldur x30, [sp,#8]       // retrieve return address
    add sp,sp,#16           // restore original value of stack pointer!
    mul x0,x0,x1            // return factorial(N-1) * N
    ret



// unsigned long long int recursiveFibonacci  long long int N) {

recursiveFibonacci:
    cmp x0, #2              // if N > 2
    B.HS fib1               //    evaluate the function recursively
    ret                     // for N = 1 or 0, just return N
fib1:
    sub sp, sp, #32         // Make room on stack for N, a, return value; sp must be multiple of 16!
    stur x30, [sp,#24]      // save return address on stack
    stur x0, [sp,#16]       // save N on stack
    sub x0, x0, #2
    bl recursiveFibonacci   // call function recursively on N-2
    stur x0, [sp,#8]        // save a on stack
    ldur x0, [sp,#16]       // retrieve N from the stack
    sub x0, x0, #1
    bl recursiveFibonacci   // call function recursive on N-1
    ldur x30, [sp,#24]      // retrieve return address from the stack
    ldur x1, [sp,#8]        // retrieve a from the stack into x1
    add sp, sp, #32
    add x0, x0, x1          // x0 now contains a+b
    ret


